#============================================================================
# doxygen_base.mk - generate PDF and HTML output from doxygen input

DOXYGEN_BASE_MK =

# prereqs
#         doxygen.ac

CREATE_AM_MACROS_MK +=
INSTALL_DIR_MK  +=

include $(top_srcdir)/snippets/dx_doxygen.am

docdir=$(datadir)/doc/$(PACKAGE)
doc_DATA		=
noinst_DATA		=
local_data =
local_data_deps =

EXTRA_DIST		+= $(DX_CONFIG)
DISTCLEANFILES          += $(DX_DISTCLEANFILES)
MOSTLYCLEANFILES        += $(DX_CLEANFILES)


##################
# html

if    DX_COND_html

#-----------------------------------
# distribution
# only distribute if we can generate

# depend upon doxygen-run as there's no specific target for HTML
local_data_deps		+= doxygen-run

# what to distribute
EXTRA_DIST		+= $(DX_DOCDIR)/html

endif DX_COND_html

#-----------------------------------
# installation
# always install; archive should have docs

# use install_dirs.mk for recursive directory installation and uninstallation
# add to list of rules (used below)
local_data              += doxy-html

src_htmldir		= $(DX_DOCDIR)/html
dst_htmldir		= $(docdir)/html

install-doxy-html:
	@$(NORMAL_INSTALL)
	src_dir=$(src_htmldir); dst_dir=$(dst_htmldir); $(install_dir)

uninstall-doxy-html:
	@$(NORMAL_UNINSTALL)
	src_dir=$(src_htmldir); dst_dir=$(dst_htmldir); $(uninstall_dir)



##################
# pdf

if    DX_COND_pdf

#-----------------------------------
# distribution
# only distribute if we can generate

local_data_deps		+= doxygen-pdf

# what to distribute
EXTRA_DIST		+= $(DX_DOCDIR)/$(DX_PROJECT).pdf

endif DX_COND_pdf


#-----------------------------------
# installation
# always install; archive should have docs

doc_DATA		+= $(DX_DOCDIR)/$(DX_PROJECT).pdf


##################
# general
if DX_COND_doc

# this is needed to trigger doxygen run 
noinst_DATA 		+= $(local_data_deps)

EXTRA_DIST		+= $(DX_DOCTAG)

endif DX_COND_doc

# add custom installation rules if required

install-data-local  : $(local_data:%=install-%)
uninstall-local     : $(local_data:%=uninstall-%)

